/**
 * 给列表根据每一项prop属性与给定的数据组合带有数据的列表
 * @param list 带有prop属性的列表
 * @param data 数据
 * @param addToLabel 是否将数据加到 label 上
 * @returns 返回处理后的列表
 */
export function assignPropValue<T>(
  list: readonly (T & { prop: string; label: string })[],
  data: Record<string, any>,
  addToLabel = false
) {
  return list.map((item) => {
    const { prop, label, ...restField } = item;
    const count = data[prop];
    return {
      ...restField,
      label: addToLabel ? `${label}(${count})` : label,
      count,
    };
  });
}
